package com.rjconsultores.ventaboletos.dao.hibernate;

import java.util.List;

import org.hibernate.Criteria;
import org.hibernate.SessionFactory;
import org.hibernate.criterion.Restrictions;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.beans.factory.annotation.Qualifier;
import org.springframework.stereotype.Repository;

import com.rjconsultores.ventaboletos.dao.MensagemRecusaDAO;
import com.rjconsultores.ventaboletos.dao.sqlbuilder.SQLBuilder;
import com.rjconsultores.ventaboletos.entidad.MensagemRecusa;

@Repository("MensagemRecusaDAO")
public class MensagemRecusaHibernateDAO extends GenericHibernateDAO<MensagemRecusa, Integer> implements MensagemRecusaDAO {

	@Autowired
	private SQLBuilder sqlBuilder;

	@Autowired
	public MensagemRecusaHibernateDAO(@Qualifier("sessionFactory") SessionFactory factory) {
		setSessionFactory(factory);
	}

	@SuppressWarnings("unchecked")
	@Override
	public List<MensagemRecusa> obtenerTodos() {
		Criteria c = getSession().createCriteria(getPersistentClass());
		c.add(Restrictions.eq(ACTIVO, Boolean.TRUE));
		return c.list();
	}
	
	@SuppressWarnings("unchecked")
	@Override
	public List<MensagemRecusa> buscarPorCategoriaPadraoAPI(Integer categoriaId) {
		Criteria c = getSession().createCriteria(getPersistentClass());
		c.add(Restrictions.eq(ACTIVO, Boolean.TRUE));
		c.add(Restrictions.eq("padraoAPI", Boolean.TRUE));
		c.add(Restrictions.eq("categoria.categoriaId", categoriaId));
		return c.list();
	}

}
